# term.py

#### Hilfsfunktionen:
def letzter(wort):
    '''wort muss mindestens ein Zeichen enthalten'''
    return wort[len(wort)-1]

def holeNamen(wort):
    '''spaltet am ersten Zeichen, das kein für Python 3.x
    zulässiges Zeichen in Namen ist'''
    if wort.isalpha():
        return wort,''
    name=''
    for zeichen in wort:
        if zeichen.isalpha() or zeichen=='_':
            name+=zeichen
        elif len(name)>0 and zeichen.isalnum(): # vorn keine Zahl
            name+=zeichen
        else:
            return name,wort[len(name):]

def UpdateTerm(term, alt, neu):
    '''Passt den Term an einen geaenderten Faktornamen an.'''
    if not alt in term:
        return term
    ## Buchstabenkette am Anfang holen
    buchstaben=holeNamen(term)[0]
    if buchstaben==alt: ## ersetzen und hinten weiter suchen
        return neu+UpdateTerm(term[len(alt):],alt,neu)
    if buchstaben=='': ## nachten ersten Zeichen weiter suchen
        return term[:1]+UpdateTerm(term[1:],alt,neu)
    else: ## in der Kette weiter suchen
        return term[:len(buchstaben)]+UpdateTerm(term[len(buchstaben):],alt,neu)

def string_in_Zahl(ZahlString):
    '''Die Funktion bestimmt zu einem Zahlstring den Zahlenwert
    und gibt im Misserfolgsfall 0.0 zurueck.'''
    try:
        wert=float(ZahlString)
    except Exception:
        wert=0.0
    return wert

##term='-dx()*x()+3*xq()-xxx()'
##print( term )
##term=UpdateTerm(term, 'x','y')
##print( term )
##term='Treffen()*2/5000.0'
##term=UpdateTerm(term, 'Treffen','ZusammenTreffen')
##print( term )
##term='Treffen(1)*2/5000.0'
##term=UpdateTerm(term, 'Treffen','ZusammenTreffen')
##print( term )
##term='ZusammenTreffen(1)*2/5000.0'
##term=UpdateTerm(term, 'Treffen','ZusammenTreffen')
##print( term )
##term='x1()-y_und_33()'
##print( term )
##term=UpdateTerm(term, 'x1','y22')
##print( term )
##term=UpdateTerm(term, 'y_und_33','x_1')
##print( term )
